<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
       <el-form-item label="公式编号" prop="formulaCode">
        <el-input v-model="formData.formulaCode" placeholder="请输入公式编号" readonly/>
      </el-form-item>
      <el-form-item label="变量名称" prop="name">
        <el-input v-model="formData.name" placeholder="请输入变量名称" />
      </el-form-item>
      <el-form-item label="设备ID" prop="deviceId">
        <el-input v-model="formData.deviceId" placeholder="请输入设备ID" />
      </el-form-item>
      <el-form-item label="地址ID" prop="attributeId">
        <el-input v-model="formData.attributeId" placeholder="请输入地址ID" />
      </el-form-item>
      <el-form-item label="地址名称" prop="attributeName">
        <el-input v-model="formData.attributeName" placeholder="请输入地址名称" />
      </el-form-item>
      <el-form-item label="地址" prop="address">
        <el-input v-model="formData.address" placeholder="请输入地址" />
      </el-form-item>
      <el-form-item label="示例值" prop="demoValue">
        <el-input v-model="formData.demoValue" placeholder="请输入示例值" />
      </el-form-item>
      <el-form-item label="累积量类型" prop="sumType">
        <el-radio-group v-model="formData.sumType">
          <el-radio
            v-for="dict in getStrDictOptions(DICT_TYPE.IOT_FORMULA_VAR_TYPE)"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item label="计算范围" prop="sumRange">
        <el-radio-group v-model="formData.sumRange">
          <el-radio
            v-for="dict in getStrDictOptions(DICT_TYPE.IOT_FORMULA_CAL_RANG)"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item label="备注" prop="remark">
        <el-input v-model="formData.remark" placeholder="请输入备注" />
      </el-form-item>

    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { getStrDictOptions, DICT_TYPE } from '@/utils/dict'
import { FormulaApi } from '@/api/iot/formula'

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  formulaId: undefined,
  formulaCode: undefined,
  name: undefined,
  deviceId: undefined,
  attributeId: undefined,
  attributeName: undefined,
  address: undefined,
  demoValue: undefined,
  sumType: undefined,
  sumRange: undefined,
  remark: undefined,
  isEnable: undefined,
})
const formRules = reactive({
  formulaId: [{ required: true, message: '计算公式ID不能为空', trigger: 'blur' }],
  name: [{ required: true, message: '变量名称不能为空', trigger: 'blur' }],
  deviceId: [{ required: true, message: '设备ID不能为空', trigger: 'blur' }],
  attributeId: [{ required: true, message: '地址ID不能为空', trigger: 'blur' }],
  attributeName: [{ required: true, message: '地址名称不能为空', trigger: 'blur' }],
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number, formulaId: number, formulaCode: string) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  formData.value.formulaId = formulaId
  formData.value.formulaCode = formulaCode
  console.log("formulaCode", formulaCode)
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await FormulaApi.getFormulaDetail(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value
    if (formType.value === 'create') {
      await FormulaApi.createFormulaDetail(data)
      message.success(t('common.createSuccess'))
    } else {
      await FormulaApi.updateFormulaDetail(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    formulaId: undefined,
    formulaCode: undefined,
    name: undefined,
    deviceId: undefined,
    attributeId: undefined,
    attributeName: undefined,
    address: undefined,
    demoValue: undefined,
    sumType: undefined,
    sumRange: undefined,
    remark: undefined,
    isEnable: undefined,
  }
  formRef.value?.resetFields()
}
</script>
